unit Unit1;

{
Programmfunktion:
           adsb
           Empfangen Daten vom SDR Synchron
Hersteller:                         URL: string;
  HTMLText: wvstring;
  HTMLErr: integer;

           LinSoft Jürgen linder (juelin) dg5uap@darc.de
Lizens:
           privat
Hardware:
           RTL2832SDR
Software:
           Folgende Files
           adsb.exe, adsb.ico, adsb.lpi, adsb.lpr, adsb.lps, adsb.res, rtl_sdr.pas, librtlsdr.dll, unit1.lfm, unit1.pas müssen im Soucepfad vorhanden sein

wie Compelieren:
           Lazarus IDE mit FPC
wie Ausführen:
           Ausführen adsb.exe (Icon)
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  rtl_sdr, StdCtrls, ExtCtrls, uWVBrowser, ZConnection,
  ZDataset, ZAbstractRODataset, Math, uWVTypes,
  uWVTypeLibrary, System.UITypes, LCLIntf, LCLType,
  uWVWindowParent, uWVLoader, uWVBrowserBase,
  uWVWinControl;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Timer1: TTimer;
    Timer2: TTimer;
    WVBrowser1: TWVBrowser;
    WVWindowParent1: TWVWindowParent;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure WVBrowser1AfterCreated(Sender: TObject);
    procedure WVBrowser1InitializationError(Sender: TObject;
      aErrorCode: HRESULT; const aErrorMessage: wvstring);
    procedure WVBrowser1NavigationCompleted(Sender: TObject;
      const aWebView: ICoreWebView2;
      const aArgs: ICoreWebView2NavigationCompletedEventArgs);
    procedure WVBrowser1RetrieveMHTMLCompleted(Sender: TObject;
      aResult: boolean; const aMHTML: wvstring);
    procedure ZConnection1AfterConnect(Sender: TObject);
  private
    function BinToInt(Bin_Text: string): integer;                               // wandelt Binäre Darstellung in Bin_Text in Integer und gibt den zurück
    function HexToInt(Hex_Text: string): integer;                               // wandelt Hexadecimale Darstellung in Hex_Text in Integer und gibt den zurück
    procedure rtlsdr_empfang;                                                   // empfangen Daten vom SDR, Aufbereiten und Anzeigen
    procedure Loeflugtab;                                                       // Löschen Flüge-Tabelle
    procedure Loefluganz;                                                       // Löschen Flüge-Anzeige
    procedure Fluganz;                                                          // Löschen Flüge-Anzeige
    procedure Ladenflug(icao, mode, flight, land, gesellschaft, von, nach, ftype: string; alt, speed, heading, msg, adsb_ver: integer; lat, lon: double);  // Updaten oder Anlegen Flug in Tabelle
    procedure Flugloe;                                                          // Löschen Flüge von denen ich länger als 10 Sekunden keine Daten empfangen habe aus Tabelle
  public                                                                        // Anzeigen aktive Flüge
    procedure Zeile1(anzzeile: TLabel);                                         // Anzeigen Zeile1 mit Form#.Label# in anzzeile
  end;

type tflight = record
  status: string;        // F/B
  zeile: integer;        // Anzeigezeile in Memo2
  zeit: TTime;           // Uhrzeit letzter Datenempfang
  icao: string;          // ICAO-Id
  mode: string;          // S/Blank
  flight: string;        // Flugnummer                                                                                                                                                                                                                                                                                                                                                                                                           // Flugnummer
  alt: integer;          // Höhe (Meter)
  speed: integer;        // Geschwindigkeit (Km/h)
  heading: integer;      // Richtung (Grad)
  lat: double;           // Latitude
  lon: double;           // Longitude
  msg: integer;          // Nachrfichtennummer
  land: string;          // Land
  gesellschaft: string;  // Fluggesellschaft
  von: string;           // Abflughafen
  nach: string;          // Zielflughafen
  ftype: string;         // Flugzeugtype
  adsb_ver: integer;     // ADS-B Nachrichtenversion
end;

const
  ADSB_RATE: Tuint32_t = 2400000;                                               // Sample Rate in Saples/Sekunde
  ADSB_FREQ: Tuint32_t = 1090000000;                                            // ADS-B Frequenz in Hz
  DEFAULT_BUF_LENGTH: Tuint32_t = 262144;                                       // Puggergröße in Byte
  AUTO_GAIN: longint = 49;                                                      // Lautstärke
  FUNC_ON: longint = 1;                                                         // Funktion einschalten
  FUNC_OFF: longint = 0;                                                        // Funktion ausschalten
  MAX_ADSB_TAB = 25;                                                            // Maximale Anzahl Einträge in ADS-B Tabelle

var
  Form1: TForm1;
  JaNein: word;                                                                 // Ergebnis Ja/Nein Abfrage
  Closestat: integer;                                                           // Merker ob Programm beendet werden darf. 0=Ja 1=Nein
  abbruch: Boolean;                                                             // Programm-Abbruch. Wenn True wird ohne Abfrage das Programm abgebrochen
  mtasts: integer;                                                              // Dürfen die Buttons betätigt werden. 1=Ja 0=Nein
  mlauf: integer;                                                               // Welche Eingabe ist zulässig (1..n) 0=keine Eingabe
  Tag: integer;                                                                 // Datum Tag
  Monat: integer;                                                               // Datum Monat
  Jahr: integer;                                                                // Datum Jahr
  BUser: string;                                                                // Username der angemeldet ist
  sta: integer;                                                                 // Status für Initialisierung der Variablen bei Programmstart. 1=vor Init, 2=nach Init
  vers: string;                                                                 // Versionsnummer des Programms
  anzrec: Integer;                                                              // Anzahl Sätze gelesen aus Datenbank
  sperr: integer;                                                               // Sperre für Buttons 0=gesperrt, 1=frei
  sdrdevice: string;                                                            // Name des SDR-Devices
  msdropen: Boolean;                                                            // SDR-Device geöffnet (True=Ja)
  anzsdr: integer;                                                              // Anzahl SDR-Devices
  msdrreceive: Boolean;                                                         // ASD-B Daten vom SDR-Device werden empfangen
  adsbdev: Tuint32_t;                                                           // ADS-B Devicenummer
  adsbgen: string;                                                              // ADS-B Devicename
  tuner: string;                                                                // ADS-B Tunername
  sdrdev: longint;                                                              // Devicenummer vom Open SDR
  sdropennum: Prtlsdr_dev_t;                                                    // Opennummer für Close SDR-Device
  Daten_Len: Tuint32_t;                                                         // Länge der Empfangsdaten vom SDR
  Empfang: Boolean;                                                             // Empfang vom SDR läuft
  tfOut: TextFile;                                                              // Ausgabe Daten in Textfile
  Flug: array [1..MAX_ADSB_TAB] of tflight;                                               // Tabelle aktive Flüge
  aFlug: integer;                                                               // Anzahl der aktiven Flüge
  dcon: integer;                                                                // Connect zur Datenbank 0=Nein 1=Ja
  herrmsg: string;                                                              // Fehlermeldung von Datenbank
  latodd: double;                                                               // Latitude odd Parity
  lateven: double;                                                              // Latitude even Parity
  lonodd: double;                                                               // Longitude odd Parity
  loneven: double;                                                              // Longitude even Parity
  lat: double;                                                                  // Latitude
  lon: double;                                                                  // Longitude
  msg: integer;                                                                 // Message-Nummer
  internet: Boolean;                                                            // Daten vom Internet holen (True=Ja False=Nein)
  URL: string;                                                                  // Internetadresse URL
  HTMLText: wvstring;                                                           // HTML-Code einer Webseite
  HTMLErr: integer;                                                             // HTML-Fehler
  webseitegeladen: integer;                                                     // Merker Webseite geladen = 2
  murllad: integer;                                                             // Merker laden Webseite
zwi: double;
zwi1: double;
zwi2: double;
zwi3: double;
zwi4: double;
zwi5: double;
zwi6: double;

implementation

{$R *.lfm}

{ TForm1 }

{
  Funktion BinToInt
  wandelt Binäre Darstellung in Bin_Text in Integer und gibt den zurück
  Eingabefelder = Bin_Text
  Ausgabefelder = Result
}
function TForm1.BinToInt(Bin_Text: string): integer;
  var
    h1: integer;
    h2: integer;
    h3: integer;
    h4: string;
    h5: integer;
begin
  h1:=0;
  h2:=Length(Bin_Text);
  if h2 = 8 then
  begin
    for h3:=1 to 8 do
    begin
      h4:=Copy(Bin_Text,h3,1);
      h5:=0;
      if h3 = 1 then h5:=128;
      if h3 = 2 then h5:=64;
      if h3 = 3 then h5:=32;
      if h3 = 4 then h5:=16;
      if h3 = 5 then h5:=8;
      if h3 = 6 then h5:=4;
      if h3 = 7 then h5:=2;
      if h3 = 8 then h5:=1;
      if h4 = '1' then h1:=h1+h5;
    end;
  end;
  Result:=h1;
end;

{
  Funktion HexToInt
  wandelt Hexadecimale Darstellung in Hex_Text in Integer und gibt den zurück
  Eingabefelder = Hex_Text
  Ausgabefelder = Result
}
function TForm1.HexToInt(Hex_Text: string): integer;
  var
    h1: integer;
    h2: integer;
    h3: integer;
    h4: string;
    h5: integer;
    h6: string;
    h7: integer;
begin
  h1:=0;
  h2:=Length(Hex_Text);
  if ((h2 = 1) or (h2 = 2)) then
  begin
    h6:=Copy(Hex_Text,1,1);
    h4:=Upcase(h6);
    h5:=0;
    h7:=0;
    if h4 = '0' then h5:=0;
    if h4 = '1' then h5:=1;
    if h4 = '2' then h5:=2;
    if h4 = '3' then h5:=3;
    if h4 = '4' then h5:=4;
    if h4 = '5' then h5:=5;
    if h4 = '6' then h5:=6;
    if h4 = '7' then h5:=7;
    if h4 = '8' then h5:=8;
    if h4 = '9' then h5:=9;
    if h4 = 'A' then h5:=10;
    if h4 = 'B' then h5:=11;
    if h4 = 'C' then h5:=12;
    if h4 = 'D' then h5:=13;
    if h4 = 'E' then h5:=14;
    if h4 = 'F' then h5:=15;
    h7:=h5;
    if h2 = 2 then
    begin
      h7:=h5*16;
      h6:=Copy(Hex_Text,2,1);
      h4:=Upcase(h6);
      h5:=0;
      if h4 = '0' then h5:=0;
      if h4 = '1' then h5:=1;
      if h4 = '2' then h5:=2;
      if h4 = '3' then h5:=3;
      if h4 = '4' then h5:=4;
      if h4 = '5' then h5:=5;
      if h4 = '6' then h5:=6;
      if h4 = '7' then h5:=7;
      if h4 = '8' then h5:=8;
      if h4 = '9' then h5:=9;
      if h4 = 'A' then h5:=10;
      if h4 = 'B' then h5:=11;
      if h4 = 'C' then h5:=12;
      if h4 = 'D' then h5:=13;
      if h4 = 'E' then h5:=14;
      if h4 = 'F' then h5:=15;
      h7:=h7+h5;
    end;
  end;
  Result:=h7;
end;

{
  Procedure Zeile1
      zeigt die Zeile1 in Form1.Label1 an
       mit Hersteller, Programmname und Datum
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Zeile1(anzzeile: TLabel);
begin
  anzzeile.Caption:=widechar(169)+'LINSOFT         R T L S D R        ADS-B               Datum: '+FormatDateTime('DD.MM.YYYY',now);
end;

{
Procedure FormCreate
      initialisiert Variable,
      setzt Username, Datum und Programmversion.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormCreate(Sender: TObject);
var
  heute: string;
  h1: integer;
  h3: string;
  Rec: LongRec;
begin
  Closestat:=0;
  mtasts:=1;
  mlauf:=0;
  abbruch:=False;
  BUser:='                                                     ';
  try
    BUser:=SysUtils.GetEnvironmentVariable('USERNAME');
  except
    BUser:='unknown';
  end;
  heute:=FormatDateTime('DD.MM.YYYY',now);
  h1:=StrLen(PChar(heute));
  if (h1 = 10) then
  begin
    h3:=Copy(heute, 1, 2);
    Tag:=StrToInt(h3);
    h3:=Copy(heute, 4, 2);
    Monat:=StrToInt(h3);
    h3:=Copy(heute, 7, 4);
    Jahr:=StrToInt(h3);
  end;
  ZConnection1.Connected:=False;
  ZQuery1.Active:=False;
  Rec:=LongRec(GetFileVersion(ParamStr(0)));
  vers:=Format('%.*d.%.*d', [2, Rec.Hi,2, Rec.Lo]);
  abbruch:=false;
  sta:=2;
  dcon:=0;
end;

{
  Procedure Loeflugtab
      löschen Flüge-Tabelle
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Loeflugtab;
  var
    h1: integer;
begin
  aFlug:=0;
  for h1:=1 to MAX_ADSB_TAB do
  begin
    Flug[h1].status:='F';
    Flug[h1].zeile:=0;
    Flug[h1].zeit:=StrToTime('00:00:00');
    Flug[h1].icao:='';
    Flug[h1].mode:='';
    Flug[h1].flight:='';
    Flug[h1].alt:=0;
    Flug[h1].speed:=0;
    Flug[h1].heading:=0;
    Flug[h1].lat:=0;
    Flug[h1].lon:=0;
    Flug[h1].msg:=0;
    Flug[h1].land:='';
    Flug[h1].gesellschaft:='';
    Flug[h1].von:='';
    Flug[h1].nach:='';
    Flug[h1].ftype:='';
  end;
end;

{
  Procedure Loefluganz
      löschen Flüge-Anzeige
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Loefluganz;
  var
    h1: integer;
begin
  Memo2.Lines.Clear;
  Memo2.Lines.Add('Flugdaten        Anzahl aktive Flüge: '+IntToStr(aFlug));
  Memo2.Lines.Add('ICAO   Mode Flight      Alt Speed  Heading Latitude Longitude Msg Land                                               Fluggesellschaft                                   Flugzeugtype                                       Abflughafen                                        Zielflughafen');
//                 123456  S   12345678 123456  1234     1234  123,123   123,123 123 123456789.123456789.123456789.123456789.123456789. 123456789.123456789.123456789.123456789.123456789. 123456789.123456789.123456789.123456789.123456789. 123456789.123456789.123456789.123456789.123456789. 123456789.123456789.123456789.123456789.123456789.
  Memo2.Lines.Add('--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------');
  for h1:=1 to MAX_ADSB_TAB do
  begin
    Memo2.Lines.Add('');
  end;
  Memo2.Lines[0]:=Memo2.Lines[0];
end;
{
  Procedure Fluganz
      Anzeigen aktive Flüge
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Fluganz;
  var
    h1: integer;
    h2: integer;
    h3: integer;
    h4: string;
    h5: string;
    h6: integer;
    h7: string;
begin
  h1:=1;
  h6:=0;
  aFlug:=0;
  for h2:=1 to MAX_ADSB_TAB do
  begin
    if h1 = 1 then
    begin
      if Flug[h2].status = 'B' then
      begin
        aFlug:=aFlug + 1;
        h4:=Flug[h2].icao+'  '+Flug[h2].mode+'   ';
        h5:=Flug[h2].flight;
        h3:=Length(h5);
        while h3 < 8 do
        begin
          h5:=h5+' ';
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=IntToStr(Flug[h2].alt);
        h3:=Length(h5);
        while h3 < 6 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+'  ';
        h5:=IntToStr(Flug[h2].speed);
        h3:=Length(h5);
        while h3 < 4 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+'     ';
        h5:=IntToStr(Flug[h2].heading);
        h3:=Length(h5);
        while h3 < 4 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+'  ';
        h5:=FloatToStrF(Flug[h2].lat, ffnumber, 7, 3);
        h3:=Length(h5);
        while h3 < 7 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+'   ';
        h5:=FloatToStrF(Flug[h2].lon, ffnumber, 7, 3);
        h3:=Length(h5);
        while h3 < 7 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=IntToStr(Flug[h2].msg);
        h3:=Length(h5);
        while h3 < 3 do
        begin
          h5:=' '+h5;
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=Flug[h2].land;
        h3:=Length(h5);
        while h3 < 50 do
        begin
          h5:=h5+' ';
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=Flug[h2].gesellschaft;
        h3:=Length(h5);
        while h3 < 50 do
        begin
          h5:=h5+' ';
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=Flug[h2].ftype;
        h3:=Length(h5);
        while h3 < 50 do
        begin
          h5:=h5+' ';
          h3:=Length(h5);
        end;
        h4:=h4+h5+' ';
        h5:=Flug[h2].von;
        h3:=Length(h5);
        while h3 < 50 do
        begin
          h5:=h5+' ';
          h3:=Length(h5);
        end;
        h4:=h4+h5+' '+Flug[h2].nach;
        h7:=Memo2.Lines.Strings[Flug[h2].zeile+2];
        h6:=1;
        if h7 <> h4 then
        begin
          Memo2.Lines.Strings[Flug[h2].zeile+2]:=h4;
        end;
      end else begin
        h1:=0;
      end;
    end;
  end;
  if h6 = 1 then
  begin
    Memo2.Lines.Strings[0]:='Flugdaten        Anzahl aktive Flüge: '+IntToStr(aFlug)+'  ';
  end else begin
    Memo2.Lines[0]:=Memo2.Lines[0];
  end;
end;

{
  Procedure Ladenflug
      Updaten oder einfügen Flug in Tabelle
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Ladenflug(icao, mode, flight, land, gesellschaft, von, nach, ftype: string; alt, speed, heading, msg, adsb_ver: integer; lat, lon: double);
  var
    h1: integer;
    h2: integer;
    h3: integer;
    h4: integer;
    h5: integer;
begin
  h1:=1;
  h3:=0;
  h4:=0;
  for h2:=1 to MAX_ADSB_TAB do
  begin
    if h1 = 1 then
    begin
      if Flug[h2].status = 'B' then
      begin
        if Flug[h2].icao = icao then
        begin
          h3:=h2;
          h1:=0;
        end;
      end else begin
        h4:=h2;
        h1:=0;
      end;
    end;
  end;
  h5:=0;
  if h3 > 0 then
  begin
    msg:=Flug[h3].msg;
    msg:=msg + 1;
    Flug[h3].zeit:=now;
    if ((flight <> Flug[h3].flight) and (flight <> '')) then
    begin
      h5:=1;
      Flug[h3].flight:=flight;
    end;
    if alt <> Flug[h3].alt then
    begin
      h5:=1;
      Flug[h3].alt:=alt;
    end;
    if speed <> Flug[h3].speed then
    begin
      h5:=1;
      Flug[h3].speed:=speed;
    end;
    if heading <> Flug[h3].heading then
    begin
      h5:=1;
      Flug[h3].heading:=heading;
    end;
    if lat <> Flug[h3].lat then
    begin
      h5:=1;
      Flug[h3].lat:=lat;
    end;
    if lon <> Flug[h3].lon then
    begin
      h5:=1;
      Flug[h3].lon:=lon;
    end;
    if msg <> Flug[h3].msg then
    begin
      h5:=1;
      Flug[h3].msg:=msg;
    end;
    if ((land <> Flug[h3].land) and (land <> '')) then
    begin
      h5:=1;
      Flug[h3].land:=land;
    end;
    if ((gesellschaft <> Flug[h3].gesellschaft) and (gesellschaft <> '')) then
    begin
      h5:=1;
      Flug[h3].gesellschaft:=gesellschaft;
    end;
    if ((von <> Flug[h3].von) and (von <> '')) then
    begin
      h5:=1;
      Flug[h3].von:=von;
    end;
    if ((nach <> Flug[h3].nach) and (nach <> '')) then
    begin
      h5:=1;
      Flug[h3].nach:=nach;
    end;
    if ((ftype <> Flug[h3].ftype) and (ftype <> '')) then
    begin
      h5:=1;
      Flug[h3].ftype:=ftype;
    end;
    if ((adsb_ver <> Flug[h3].adsb_ver) and (adsb_ver > 0)) then
    begin
      h5:=1;
      Flug[h3].adsb_ver:=adsb_ver;
    end;
  end else begin
    if h4 > 0 then
    begin
      h5:=1;
      msg:=1;
      Flug[h4].status:='B';
      Flug[h4].zeile:=h4;
      Flug[h4].zeit:=now;
      Flug[h4].icao:=icao;
      Flug[h4].mode:=mode;
      Flug[h4].flight:=flight;                                                                                                                                                                                                                                                                                                                                                                                                           // Flugnummer
      Flug[h4].alt:=alt;
      Flug[h4].speed:=speed;
      Flug[h4].heading:=heading;
      Flug[h4].lat:=lat;
      Flug[h4].lon:=lon;
      Flug[h4].msg:=msg;
      Flug[h4].land:=land;
      Flug[h4].gesellschaft:=gesellschaft;
      Flug[h4].von:=von;
      Flug[h4].nach:=nach;
      Flug[h4].ftype:=ftype;
      Flug[h4].adsb_ver:=adsb_ver;
    end;
  end;
  if h5 = 1 then Fluganz;
end;

{
  Procedure Flugloe
      Löschen Flüge von denen ich länger als 10 Sekunden keine Daten empfangen habe aus Tabelle
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Flugloe;
  var
    h1: integer;
    h2: integer;
    h3: integer;
    h4: string;
    h5: integer;
    h6: integer;
    h7: string;
    h8: integer;
    h9: integer;
    ha: integer;
    hb: integer;
begin
  if aFlug > 0 then
  begin
    h1:=1;
    h3:=1;
    h4:=TimeToStr(now);
    h5:=Length(h4);
    if h5 = 8 then
    begin
      h7:=Copy(h4,1,2);
      h8:=StrToInt(h7);
      h9:=h8*3600;
      h7:=Copy(h4,4,2);
      h8:=StrToInt(h7);
      h9:=h9+h8*60;
      h7:=Copy(h4,7,2);
      h8:=StrToInt(h7);
      h9:=h9+h8;
    end;
    while h3 > 0 do
    begin
      h3:=0;
      for h2:=1 to MAX_ADSB_TAB do
      begin
        if h1 = 1 then
        begin
          if Flug[h2].status = 'B' then
          begin
            h4:=TimeToStr(Flug[h2].zeit);
            h5:=Length(h4);
            if h5 = 8 then
            begin
              h7:=Copy(h4,1,2);
              h8:=StrToInt(h7);
              h6:=h8*3600;
              h7:=Copy(h4,4,2);
              h8:=StrToInt(h7);
              h6:=h6+h8*60;
              h7:=Copy(h4,7,2);
              h8:=StrToInt(h7);
              h6:=h6+h8;
              ha:=0;
              if h9 >= h6 then
              begin
                ha:=h9 - h6;
              end else begin
                if ((h9 < 7201) and (h6 > 75600)) then
                begin
                  ha:=86400 - h6 + h9;
                end;
              end;
              if ha > 20 then
              begin
                h3:=h2;
                h1:=0;
                ha:=Flug[h2].zeile;
                if ha < MAX_ADSB_TAB then
                begin
                  for hb:=ha to MAX_ADSB_TAB-1 do
                  begin
                    Memo2.Lines.Strings[hb+2]:=Memo2.Lines.Strings[hb+3];
                    Flug[hb+1].zeile:=hb;
                  end;
                end;
                Memo2.Lines.Strings[27]:='';
                if h2 < MAX_ADSB_TAB then
                begin
                  for ha:=h2 to MAX_ADSB_TAB-1 do
                  begin
                    Flug[ha]:=Flug[ha+1];
                  end;
                end;
                Flug[MAX_ADSB_TAB].status:='F';
                Flug[MAX_ADSB_TAB].zeile:=0;
                Flug[MAX_ADSB_TAB].zeit:=StrToTime('00:00:00');
                Flug[MAX_ADSB_TAB].icao:='';
                Flug[MAX_ADSB_TAB].mode:='';
                Flug[MAX_ADSB_TAB].flight:='';
                Flug[MAX_ADSB_TAB].alt:=0;
                Flug[MAX_ADSB_TAB].speed:=0;
                Flug[MAX_ADSB_TAB].heading:=0;
                Flug[MAX_ADSB_TAB].lat:=0;
                Flug[MAX_ADSB_TAB].lon:=0;
                Flug[MAX_ADSB_TAB].msg:=0;
                Flug[MAX_ADSB_TAB].land:='';
                Flug[MAX_ADSB_TAB].gesellschaft:='';
                Flug[MAX_ADSB_TAB].von:='';
                Flug[MAX_ADSB_TAB].nach:='';
                Flug[MAX_ADSB_TAB].ftype:='';
                Fluganz;
              end;
            end;
          end else begin
            h1:=0;
          end;
        end;
      end;
    end;
  end;
end;

{
  Procedure Timer1Timer
      starten Empfang Daten vom SDR und
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  rtlsdr_empfang;
end;

{
  Procedure Timer2Timer
      laden fehlende Daten aus dem Internet
      mit ICAO-Id aus Tabelle Flug
      Flugnummer, Fluggesellschaft, Flugzeugtype,
      Startflughafen, Zielflughafen, Land
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Timer2Timer(Sender: TObject);
  var
    h1: integer;
    h2: integer;
    hicao: string;
    hflight: string;
    hges: string;
    hvon: string;
    hnach: string;
    htype: string;
    hland: string;
begin
  Timer2.Enabled:=False;
  h1:=1;
  for h2:=1 to MAX_ADSB_TAB do
  begin
    if h1 = 1 then
    begin
      if Flug[h2].status = 'B' then
      begin
        hicao:=Flug[h2].icao;
        hflight:='';
        hges:='';
        hvon:='';
        hnach:='';
        htype:='';
        hland:='';
        murllad:=0;
        webseitegeladen:=0;
hicao:='06A080';
        URL:='https://opensky-network.org/api/states/all?icao24='+lowercase(hicao);
        HTMLErr:=0;
        HTMLText:='';
        if GlobalWebView2Loader.InitializationError then
        begin
          showmessage(UTF8Encode(GlobalWebView2Loader.ErrorMessage));
        end else begin
          if GlobalWebView2Loader.Initialized then
          begin
            if WVBrowser1.Initialized then
            begin
              WVBrowser1.Navigate(UTF8Decode(URL));
            end else begin
              WVBrowser1.CreateBrowser(WVWindowParent1.Handle);
            end;
          end;
        end;
      end else begin
        h1:=0;
      end;
    end;
  end;
  Application.ProcessMessages;
  sleep(300);
  if internet then Timer2.Enabled:=True;
end;

{
  Procedure WVBrowser1AfterCreated
      laden URL in WVWindowParent1
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.WVBrowser1AfterCreated(Sender: TObject);
begin
  WVWindowParent1.UpdateSize;
  WVBrowser1.Navigate(UTF8Decode(URL));
end;

{
  Procedure WVBrowser1InitializationError
      Fehler beim Laden der Webseite
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.WVBrowser1InitializationError(Sender: TObject;
  aErrorCode: HRESULT; const aErrorMessage: wvstring);
begin
  showmessage(UTF8Encode(aErrorMessage));
  HTMLErr:=2;
end;

{
  Procedure WVBrowser1NavigationCompleted
      Webseite korrekt geladen
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.WVBrowser1NavigationCompleted(Sender: TObject;
  const aWebView: ICoreWebView2;
  const aArgs: ICoreWebView2NavigationCompletedEventArgs);
begin
  WVBrowser1.RetrieveHTML;
  webseitegeladen:=1;
end;

{
  Procedure WVBrowser1RetriveMHTMLCompleted
      laden HTML-Code der Webseite korrekt oder Fehlerhaft
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.WVBrowser1RetrieveMHTMLCompleted(Sender: TObject;
  aResult: boolean; const aMHTML: wvstring);
begin
  if aResult then
  begin
    HTMLText:=aMHTML;
    if webseitegeladen = 1 then webseitegeladen:=2;
  end else begin
    HTMLErr:=1;
  end;
end;

{
  Procedure Connection1AfterConnect
      Connect zur Datenbank durchgeführt
      wenn ok setzen Variable dcon
      wenn Fehler Fehlermaldung und Abbruch.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.ZConnection1AfterConnect(Sender: TObject);
begin
  if ZConnection1.Connected then
  begin
    dcon:=1;
    ZQuery1.SQL.Clear;
    ZQuery1.SQL.Add('SET GLOBAL max_connections=8001');
    try
      ZQuery1.ExecSQL;
    except
      on E: Exception do
      begin
        herrmsg:=E.Message;
      end;
    end;
    ZQuery1.Close;
  end else begin
    dcon:=2;
    JaNein:=messagedlg('keine Verbindung zur Datenbank flight', mtError, [mbOk], 0);
    close;
  end;
end;

{
  Procedure rtlsdr_empfang
      Empfäng 14 Byte Daten vom SDR und
      bereitet die empfangenen ADS-B Daten in buf
      für die Anzeige auf und gibt sie in Memo1 (oben) aus.
      Die aufbereiteten ADS-B Daten werden in Memo2 (unten) ausgegeben.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.rtlsdr_empfang;
  var
    h1: pointer;
    h2: longint;
    h3: integer;
    h4: string;
    h5: string;
    h8: integer;
    h9: string;
    ha: integer;
    hb: array [0..13] of Char;
    hc: char;
    hd: integer;
    hf: string;
    hdf: integer;
    hca: integer;
    htc: integer;
    hicao: string;
    hpi: string;
    hmes1: string;
    hmes2: string;
    hdaten: string;
    he2: pointer;
    he3: pointer;
    he4: longint;
    he5: longint;
    he6: longint;
    status: string;
    zeile: integer;
    zeit: TTime;
    icao: string;
    mode: string;
    flight: string;                                                                                                                                                                                                                                                                                                                                                                                                                   // Flugnummer
    alt: integer;
    speed: integer;
    heading: integer;
    land: string;
    gesellschaft: string;
    von: string;
    nach: string;
    ftype: string;
    adsb_ver: integer;
    categ: integer;
    zeich1: char;
    zeich2: char;
    zeich3: char;
    zeich4: char;
    zeich5: char;
    zeich6: char;
    zeich7: char;
    zeich8: char;
    iv: string;
    ib: string;
    il: string;
    it: string;
    iw: integer;
    i1: integer;
    i2: integer;
    i3: integer;
    i4: integer;
    i5: integer;
    i6: string;
    i7: string;
    i8: integer;
    i9: char;
    i10: integer;
    i11: integer;
    cpr: string;
    latcpr: double;
    loncpr: double;
    j: integer;
    m: integer;
    latnlodd: double;
    latnleven: double;
    u1: integer;
    u2: integer;
    u3: integer;
    u4: integer;
    latold: double;
    lonold: double;
    rech: double;
    oddeven: integer;
    phi1: double;
    phi2: double;
    delta1: double;
    delta2: double;
    d: double;
    dh: integer;
    vs: integer;
    vx: integer;
    vy: integer;
begin
  Empfang:=True;
  i7:='#ABCDEFGHIJKLMNOPQRSTUVWXYZ##### ###############0123456789######';
  while (Empfang) do
  begin
    he4:=rtlsdr_reset_buffer(sdropennum);
    he4:=0;
    he5:=14;
    he2:=@hb;
    he3:=@he4;
    he6:=rtlsdr_read_sync(sdropennum, he2, he5, he3);
    if he6 = 0 then
    begin
      hdf:=0;
      hca:=0;
      htc:=0;
      hicao:='';
      hpi:='';
      hmes1:='';
      hmes2:='';
      hdaten:='';
      flight:='';                                                                                                                                                                                                                                                                                                                                                                                                           // Flugnummer
      alt:=0;
      speed:=0;
      heading:=0;
      lat:=0;
      lon:=0;
      msg:=0;
      land:='';
      gesellschaft:='';
      von:='';
      nach:='';
      ftype:='';
      adsb_ver:=0;
      Daten_Len:=he4;
      ha:=Ord(hb[0]);
      h9:=BinStr(ha, 8);
      ha:=Length(h9);
      if ha = 8 then
      begin
        hf:='000'+Copy(h9,1,5);
        hdf:=Form1.BinToInt(hf);
        hf:='00000'+Copy(h9,6,3);
        hca:=Form1.BinToInt(hf);
      end;
      if ((Daten_Len = 14) and (Empfang)) then
      begin
        if hdf = 17 then    // hdf = 17 oder 18
        begin
          h4:='';
          for h3:=0 to Daten_Len-1 do
          begin
            h5:=hb[h3];
            h4:=h4+h5;
          end;
          h8:=Length(h4);
          hd:=h8;
          for h3:=1 to hd do
          begin
            ha:=Ord(h4[h3]);
            h9:=IntToHex(ha);
            hdaten:=hdaten+Copy(h9,7,2);
          end;
          writeln(tfOut, hdaten);
          for h3:=2 to 4 do
          begin
            ha:=Ord(h4[h3]);
            h9:=IntToHex(ha);
            hicao:=hicao+Copy(h9,7,2);
          end;
          for h3:=12 to 14 do
          begin
            ha:=Ord(h4[h3]);
            h9:=IntToHex(ha);
            hpi:=hpi+Copy(h9,7,2);
          end;
          for h3:=5 to 11 do
          begin
            ha:=Ord(h4[h3]);
            h9:=IntToHex(ha);
            hmes1:=hmes1+Copy(h9,7,2);
            hc:=h4[h3];
            if ha < 32 then hc:=' ';
            hmes2:=hmes2+hc;
          end;
          ha:=Ord(h4[5]);
          h9:=BinStr(ha, 8);
          ha:=Length(h9);
          if ha = 8 then
          begin
            hf:='000'+Copy(h9,1,5);
            htc:=Form1.BinToInt(hf);
          end;
          Form1.Memo1.Lines.Add(hdaten+' | DF='+IntToStr(hdf)+' CA='+IntToStr(hca)+' Code='+IntToStr(htc)+' ICAO='+hicao+' PI='+hpi+' Message='+hmes1+' '+hmes2);
// Version und Status des Flugzeugbetriebs
          if htc = 31 then
          begin
            ha:=Ord(h4[10]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,1,3);
              adsb_ver:=Form1.BinToInt(hf);
            end;
          end;
          icao:=hicao;
          mode:='S';
          if hca < 4 then mode:=' ';
          // 1-4   ##Flugzeugidentifikation
          // 5-8   ##Oberflächenposition
          // 9-18  ##Luftposition (mit barometrischer Höhe)
          // 19    ##Luftgeschwindigkeiten
          // 20-22 ##Luftposition (mit GNSS-Höhe)
          // 28    Flugzeugstatus
          // 29    Zelizustand und Statusinformationen
          // 31    ##Version und Status des Flugzeugbetriebs
// Flugzeugidentifikation
          if ((htc > 0) and  (htc < 5)) then
          begin
            categ:=0;
            zeich1:=' ';
            zeich2:=' ';
            zeich3:=' ';
            zeich4:=' ';
            zeich5:=' ';
            zeich6:=' ';
            zeich7:=' ';
            zeich8:=' ';
            ha:=Ord(h4[5]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,6,3);
              categ:=Form1.BinToInt(hf);
            end;
            i1:=5;
            i2:=6;
            i4:=3;
            i6:='';
            i10:=0;
            while i10 < 8 do
            begin
              ha:=Ord(h4[i1]);
              h9:=BinStr(ha, 8);
              i11:=Length(i6);
              i8:=0;
              if i11+i4 = 6 then
              begin
                i8:=1;
                i10:=i10 + 1;
                hf:='00'+i6+Copy(h9,i2,i4);
                i3:=Form1.BinToInt(hf);
                i9:=i7[i3];
                if i10 = 1 then zeich1:=i9;
                if i10 = 2 then zeich2:=i9;
                if i10 = 3 then zeich3:=i9;
                if i10 = 4 then zeich4:=i9;
                if i10 = 5 then zeich5:=i9;
                if i10 = 6 then zeich6:=i9;
                if i10 = 7 then zeich7:=i9;
                if i10 = 8 then zeich8:=i9;
              end;
              if i8 = 0 then
              begin
                i6:=Copy(h9,i2,i4);
                i5:=i4;
              end else begin
                i5:=i2+i4-1;
                i6:='';
                if i5 < 8 then i6:=Copy(h9,i5+1,8-i5);
              end;
              i2:=1;
              i11:=Length(i6);
              i4:=6-i11;
              i1:=i1+1;
            end;
            i6:=zeich1+zeich2+zeich3+zeich4+zeich5+zeich6+zeich7+zeich8;
            if ((htc = 4) and (i6 <> '        ')) then flight:=i6;
          end;
// Oberflächenposition
          if ((htc > 4) and  (htc < 9)) then
          begin
            i3:=0;
            i4:=0;
            ha:=Ord(h4[5]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,6,3);
              i3:=Form1.BinToInt(hf);
              i3:=i3 * 16;
            end;
            ha:=Ord(h4[6]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0000'+Copy(h9,1,4);
              i4:=Form1.BinToInt(hf);
              i4:=i4 + i3;
            end;
            if i4 > 0 then
            begin
              if i4 = 1 then speed:=0;
              if ((i4 > 1) and (i4 < 9)) then speed:=Round(((i4 - 1) * 0.125) * 1.852);
              if ((i4 > 8) and (i4 < 13)) then speed:=Round(((i4 - 8) * 0.25) * 1.852);
              if ((i4 > 12) and (i4 < 39)) then speed:=Round(((i4 - 12) * 0.5) * 1.852);
              if ((i4 > 38) and (i4 < 94)) then speed:=Round((i4 - 38) * 1.852);
              if ((i4 > 93) and (i4 < 109)) then speed:=Round(((i4 - 93) * 2) * 1.852);
              if ((i4 > 108) and (i4 < 124)) then speed:=Round(((i4 - 108) * 5) * 1.852);
              if i4 = 124 then speed:=Round(175 * 1.852);
            end;
            cpr:='0';
            ha:=Ord(h4[7]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              cpr:=Copy(h9,6,1);
            end;
            oddeven:=1;
            if cpr = '0' then oddeven:=2;
            ha:=Ord(h4[7]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='000000'+Copy(h9,7,2);
              i5:=Form1.BinToInt(hf);
              latcpr:=i5*65536;
            end;
            ha:=Ord(h4[8]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              latcpr:=latcpr+i5*256;
            end;
            ha:=Ord(h4[9]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0'+Copy(h9,1,7);
              i5:=Form1.BinToInt(h9);
              latcpr:=latcpr+i5;
              hf:='0000000'+Copy(h9,8,1);
              i5:=Form1.BinToInt(h9);
              loncpr:=i5*65536;
            end;
            ha:=Ord(h4[10]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              loncpr:=loncpr+i5*256;
            end;
            ha:=Ord(h4[11]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              loncpr:=loncpr+i5;
            end;
            if oddeven = 1 then
            begin
              latodd:=latcpr / 2**17;
              lonodd:=loncpr / 2**17;
            end else begin
              lateven:=latcpr / 2**17;
              loneven:=loncpr / 2**17;
            end;
            j:=Floor(59 * lateven - 60 * latodd + 0.5);
            if oddeven = 1 then
            begin
              latodd:=90 / (4 * 15 - 1) * (j - (59 * Floor(j / 59)) + latodd);
              rech:=1 - (1 - (cos(Pi / 30)) / (cos(Pi / 180 * latodd))**2);
              while ((rech < -1) or (rech > 1)) do
              begin
                if rech < 0 then
                begin
                  rech:=rech + 1
                end else begin
                  rech:=rech - 1;
                end;
              end;
              latnlodd:=Floor(2 * Pi / arccos(rech));
            end else begin
              lateven:=90 / (4 * 15) * (j - (60 * Floor(j / 60)) + lateven);
              rech:=1 - (1 - (cos(Pi / 30)) / (cos(Pi / 180 * lateven))**2);
              while ((rech < -1) or (rech > 1)) do
              begin
                if rech < 0 then
                begin
                  rech:=rech + 1
                end else begin
                  rech:=rech - 1;
                end;
              end;
              latnleven:=Floor(2 * Pi / arccos(rech));
            end;
            if i4 = 1 then
            begin
              latcpr:=latodd;
              m:=Floor(loneven * (latnleven - 1) - lonodd * latnleven + 0.5);
              loncpr:=0;
              if latnlodd <> 0 then
                loncpr:=10 * ((m - (latnlodd * Floor(m / latnlodd))) + lonodd);
            end else begin
              latcpr:=lateven;
              m:=Floor(loneven * (latnleven - 1) - lonodd * latnleven + 0.5);
              loncpr:=0;
              if latnleven <> 0 then
                loncpr:=10 * ((m - (latnleven * Floor(m / latnleven))) + loneven);
            end;
            u1:=1;
            u3:=0;
            for u2:=1 to MAX_ADSB_TAB do
            begin
              if u1 = 1 then
              begin
                if Flug[u2].status = 'B' then
                begin
                  if Flug[u2].icao = icao then
                  begin
                    u3:=u2;
                    u1:=0;
                  end;
                end else begin
                  u1:=0;
                end;
              end;
            end;
            if u3 = 0 then
            begin
              if ((latcpr <> 0) or (loncpr <> 0)) then
              begin
                lat:=latcpr;
                lon:=loncpr;
              end;
            end else begin
              latold:=Flug[u3].lat;
              lonold:=Flug[u3].lon;
              u2:=1;
              if ((latold <> 0) or (lonold <> 0)) then
              begin
                if ((latcpr <> 0) or (loncpr <> 0)) then
                begin
                  phi1:=latold * (Pi / 180);
                  phi2:=latcpr * (Pi / 180);
                  delta1:=lonold * (Pi / 180);
                  delta2:=loncpr * (Pi / 180);
                  d:=2 * 6371000.785 * arcsin(sqrt((sin((phi2 - phi1)/2))**2 + cos(phi1) * cos(phi2) * (sin((delta2 - delta1)/2))**2));
                  if d > 2500 then u2:=0;
                end;
              end;
              if u2 > 0 then
              begin
                if ((latcpr <> 0) or (loncpr <> 0)) then
                begin
                  lat:=latcpr;
                  lon:=loncpr;
                end;
              end;
            end;
          end;
// 9-18 Luftposition (mit barometrischer Höhe)
// 20-22 Luftposition (mit GNSS-Höhe)
          i4:=0;
          if ((htc > 8) and  (htc < 19)) then i4:=1;
          if ((htc > 19) and  (htc < 23)) then i4:=1;
          if i4 = 1 then
          begin
            i3:=0;
            i4:=0;
            i6:='0';
            ha:=Ord(h4[6]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              if ((htc > 8) and  (htc < 19)) then
              begin
                hf:='0'+Copy(h9,1,7);
                i6:=Copy(h9,8,1);
              end;
              if ((htc > 19) and  (htc < 23)) then hf:=h9;
              i3:=Form1.BinToInt(hf);
              i3:=i3*16;
            end;
            ha:=Ord(h4[7]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0000'+Copy(h9,1,4);
              i4:=Form1.BinToInt(hf);
            end;
            i3:=i3+i4;
            if ((htc > 8) and  (htc < 19)) then
            begin
              i4:=25;
              if i6 = '0' then i4:=100;
              i5:=i3;
              if i3 > 0 then
              begin
                i3:=i5 * i4 - 1000;
                i4:=100;
                while i3 > 50175 do
                begin
                  i3:=i5 * i4 - 1000;
                  i4:=i4 - 1;
                end;
                if i3 > 0 then alt:=Round(i3 * 0.3048);
              end;
            end;
            if ((htc > 19) and  (htc < 23)) then
            begin
              if i3 > 0 then alt:=i3;
            end;
            cpr:='0';
            ha:=Ord(h4[7]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              cpr:=Copy(h9,6,1);
            end;
            oddeven:=1;
            if cpr = '0' then oddeven:=2;
            ha:=Ord(h4[7]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='000000'+Copy(h9,7,2);
              i5:=Form1.BinToInt(hf);
              latcpr:=i5*65536;
            end;
            ha:=Ord(h4[8]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              latcpr:=latcpr+i5*256;
            end;
            ha:=Ord(h4[9]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0'+Copy(h9,1,7);
              i5:=Form1.BinToInt(h9);
              latcpr:=latcpr+i5;
              hf:='0000000'+Copy(h9,8,1);
              i5:=Form1.BinToInt(h9);
              loncpr:=i5*65536;
            end;
            ha:=Ord(h4[10]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              loncpr:=loncpr+i5*256;
            end;
            ha:=Ord(h4[11]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              i5:=Form1.BinToInt(h9);
              loncpr:=loncpr+i5;
            end;
            if oddeven = 1 then
            begin
              latodd:=latcpr / 2**17;
              lonodd:=loncpr / 2**17;
            end else begin
              lateven:=latcpr / 2**17;
              loneven:=loncpr / 2**17;
            end;
            j:=Floor(59 * lateven - 60 * latodd + 0.5);
            if oddeven = 1 then
            begin
              latodd:=360 / (4 * 15 - 1) * (j - (59 * Floor(j / 59)) + latodd);
              rech:=1 - (1 - (cos(Pi / 30)) / (cos(Pi / 180 * latodd))**2);
              while ((rech < -1) or (rech > 1)) do
              begin
                if rech < 0 then
                begin
                  rech:=rech + 1
                end else begin
                  rech:=rech - 1;
                end;
              end;
              latnlodd:=Floor(2 * Pi / arccos(rech));
            end else begin
              lateven:=360 / (4 * 15) * (j - (60 * Floor(j / 60)) + lateven);
              rech:=1 - (1 - (cos(Pi / 30)) / (cos(Pi / 180 * lateven))**2);
              while ((rech < -1) or (rech > 1)) do
              begin
                if rech < 0 then
                begin
                  rech:=rech + 1
                end else begin
                  rech:=rech - 1;
                end;
              end;
              latnleven:=Floor(2 * Pi / arccos(rech));
            end;
            if i4 = 1 then
            begin
              latcpr:=latodd;
              m:=Floor(loneven * (latnleven - 1) - lonodd * latnleven + 0.5);
              loncpr:=0;
              if latnlodd <> 0 then
                loncpr:=10 * ((m - (latnlodd * Floor(m / latnlodd))) + lonodd);
            end else begin
              latcpr:=lateven;
              m:=Floor(loneven * (latnleven - 1) - lonodd * latnleven + 0.5);
              loncpr:=0;
              if latnleven <> 0 then
                loncpr:=10 * ((m - (latnleven * Floor(m / latnleven))) + loneven);
            end;
            u1:=1;
            u3:=0;
            for u2:=1 to MAX_ADSB_TAB do
            begin
              if u1 = 1 then
              begin
                if Flug[u2].status = 'B' then
                begin
                  if Flug[u2].icao = icao then
                  begin
                    u3:=u2;
                    u1:=0;
                  end;
                end else begin
                  u1:=0;
                end;
              end;
            end;
            if u3 = 0 then
            begin
              if ((latcpr <> 0) or (loncpr <> 0)) then
              begin
                lat:=latcpr;
                lon:=loncpr;
              end;
            end else begin
              latold:=Flug[u3].lat;
              lonold:=Flug[u3].lon;
              u2:=1;
              if ((latold <> 0) or (lonold <> 0)) then
              begin
                if ((latcpr <> 0) or (loncpr <> 0)) then
                begin
                  phi1:=latold * (Pi / 180);
                  phi2:=latcpr * (Pi / 180);
                  delta1:=lonold * (Pi / 180);
                  delta2:=loncpr * (Pi / 180);
                  d:=2 * 6371000.785 * arcsin(sqrt((sin((phi2 - phi1)/2))**2 + cos(phi1) * cos(phi2) * (sin((delta2 - delta1)/2))**2));
                  if d > 2500 then u2:=0;
                end;
              end;
              if u2 > 0 then
              begin
                if ((latcpr <> 0) or (loncpr <> 0)) then
                begin
                  lat:=latcpr;
                  lon:=loncpr;
                end;
              end;
            end;
          end;
// Luftgeschwindigkeiten
          if htc = 19 then
          begin
            i1:=0;
            i2:=0;
            i3:=0;
            i4:=0;
            i5:=0;
            i10:=0;
            i11:=0;
            u1:=0;
            u2:=0;
            u3:=0;
            u4:=0;
            ha:=Ord(h4[5]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,6,3);
              i1:=Form1.BinToInt(hf);
            end;
            ha:=Ord(h4[6]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,3,3);
              i2:=Form1.BinToInt(hf);
            end;
            ha:=Ord(h4[9]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0000000'+Copy(h9,4,1);
              i3:=Form1.BinToInt(hf);
            end;
            ha:=Ord(h4[9]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0000000'+Copy(h9,5,1);
              i4:=Form1.BinToInt(hf);
            end;
            ha:=Ord(h4[9]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00000'+Copy(h9,6,3);
              i8:=Form1.BinToInt(hf);
              i5:=i8 * 64;
            end;
            ha:=Ord(h4[10]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='00'+Copy(h9,1,6);
              i8:=Form1.BinToInt(hf);
              i5:=i5 + i8;
            end;
            if i4 = 0 then
            begin
              vs:=64 * (i5 - 1);
            end else begin
              vs:=-64 * (i5 - 1);
            end;
            ha:=Ord(h4[11]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0000000'+Copy(h9,1,1);
              i10:=Form1.BinToInt(hf);
            end;
            ha:=Ord(h4[11]);
            h9:=BinStr(ha, 8);
            ha:=Length(h9);
            if ha = 8 then
            begin
              hf:='0'+Copy(h9,2,7);
              i11:=Form1.BinToInt(hf);
            end;
            dh:=0;
            if i11 > 0 then
            begin
              dh:=i4 * (i11 - 1) * 25;
              if i10 = 0 then
              begin
                alt:=Round((vs + dh) * 0.3048);
              end else begin
                alt:=Round((vs - dh) * 0.3048);
              end;
            end;
            if ((i1 = 1) or (i1 = 2)) then
            begin
              ha:=Ord(h4[6]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0000000'+Copy(h9,6,1);
                u1:=Form1.BinToInt(hf);
              end;
              ha:=Ord(h4[6]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='000000'+Copy(h9,7,2);
                i8:=Form1.BinToInt(hf);
                u2:=i8 * 256;
              end;
              ha:=Ord(h4[7]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                i8:=Form1.BinToInt(h9);
                u2:=u2 + i8;
              end;
              ha:=Ord(h4[8]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0000000'+Copy(h9,1,1);
                u3:=Form1.BinToInt(hf);
              end;
              ha:=Ord(h4[8]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0'+Copy(h9,2,7);
                i8:=Form1.BinToInt(hf);
                u4:=i8 * 8;
              end;
              ha:=Ord(h4[9]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='00000'+Copy(h9,1,3);
                i8:=Form1.BinToInt(h9);
                u4:=u4 + i8;
              end;
              if ((u2 > 0) and (u4 > 0)) then
              begin
                if i1 = 1 then
                begin
                  if u1 = 0 then
                  begin
                    vx:=u2 - 1;
                  end else begin
                    vx:=-1 * (u2 - 1);
                  end;
                  if u3 = 0 then
                  begin
                    vy:=u4 - 1;
                  end else begin
                    vy:=-1 * (u4 - 1);
                  end;
                end else begin
                  if u1 = 0 then
                  begin
                    vx:=4 * (u2 - 1);
                  end else begin
                    vx:=-4 * (u2 - 1);
                  end;
                  if u3 = 0 then
                  begin
                    vy:=4 * (u4 - 1);
                  end else begin
                    vy:=-4 * (u4 - 1);
                  end;
                end;
                speed:=Round(sqrt(vx * vx + vy * vy) * 0.514444);
                heading:=Round(arctan2(vx, vy) * 360 / 2 * Pi);
              end;
            end;
            if ((i1 = 3) or (i1 = 4)) then
            begin
              ha:=Ord(h4[6]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0000000'+Copy(h9,6,1);
                u1:=Form1.BinToInt(hf);
              end;
              ha:=Ord(h4[6]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='000000'+Copy(h9,7,2);
                i8:=Form1.BinToInt(hf);
                u2:=i8 * 256;
              end;
              ha:=Ord(h4[7]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                i8:=Form1.BinToInt(h9);
                u2:=u2 + i8;
              end;
              ha:=Ord(h4[8]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0000000'+Copy(h9,1,1);
                u3:=Form1.BinToInt(hf);
              end;
              ha:=Ord(h4[8]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='0'+Copy(h9,2,7);
                i8:=Form1.BinToInt(hf);
                u4:=i8 * 8;
              end;
              ha:=Ord(h4[9]);
              h9:=BinStr(ha, 8);
              ha:=Length(h9);
              if ha = 8 then
              begin
                hf:='00000'+Copy(h9,1,3);
                i8:=Form1.BinToInt(h9);
                u4:=u4 + i8;
              end;
              if ((u1 > 0) and (u2 > 0)) then
              begin
                heading:=Round(u2 * 360 / 1024);
              end;
              if u4 > 0 then
              begin
                if i1 = 3 then
                begin
                  speed:=u4 - 1;
                end else begin
                  speed:=4 * (u4 - 1);
                end;
              end;
            end;
          end;
          i4:=0;
          i1:=Length(hicao);
          if i1 = 6 then
          begin
            it:=Copy(hicao,1,2);
            iw:=Form1.HexToInt(it);
            i4:=iw*65536;
            it:=Copy(hicao,3,2);
            iw:=Form1.HexToInt(it);
            i4:=i4+iw*256;
            it:=Copy(hicao,5,2);
            iw:=Form1.HexToInt(it);
            i4:=i4+iw;
          end;
          i5:=1;
          Form1.ZQuery1.SQL.Text:='SELECT * FROM icao';
          Form1.ZQuery1.Open;
          while not Form1.ZQuery1.EOF do
          begin
            if i5 = 1 then
            begin
              iv:=Form1.ZQuery1.Fields[0].AsString;
              ib:=Form1.ZQuery1.Fields[1].AsString;
              il:=Form1.ZQuery1.Fields[2].AsString;
              i2:=0;
              i3:=0;
              i1:=Length(iv);
              if i1 = 6 then
              begin
                it:=Copy(iv,1,2);
                iw:=Form1.HexToInt(it);
                i2:=iw*65536;
                it:=Copy(iv,3,2);
                iw:=Form1.HexToInt(it);
                i2:=i2+iw*256;
                it:=Copy(iv,5,2);
                iw:=Form1.HexToInt(it);
                i2:=i2+iw;
              end;
              i1:=Length(iB);
              if i1 = 6 then
              begin
                it:=Copy(iB,1,2);
                iw:=Form1.HexToInt(it);
                i3:=iw*65536;
                it:=Copy(iB,3,2);
                iw:=Form1.HexToInt(it);
                i3:=i3+iw*256;
                it:=Copy(iB,5,2);
                iw:=Form1.HexToInt(it);
                i3:=i3+iw;
              end;
              if ((i4 >= i2) and (i4 <= i3)) then
              begin
                if il <> '' then
                begin
                  if land = '' then land:=il;
                  i5:=0;
                end;
              end;
            end;
            Form1.ZQuery1.Next;
          end;
          Form1.ZQuery1.Close;
//          sqwk:=0;          4 stelliger Sicherheitscode
//          ##flight:='';     Flugnummer                                                                                                                                                                                                                                                                                                                                                                                                      // Flugnummer
//          ##alt:=0;         Höhe
//          ##speed:=0;       Geschwindigkeit
//          ##heading:=0;     Richtung
//          ##lat:=0;         Latitude
//          ##lon:=0;         Longitude
//          sig:=0;           Signalstärke
//          ##msg:=0;         Nachrichtennummer
//          ti:=0;            Zeit seit letzter Message
//          ##land:='';       Land
//          gesellschaft:=''; Fluggesellschaft
//          von:='';          Abflughafen
//          nach:='';         Zielflughafen
//          ftype:='';        Flugzeuftype
          Ladenflug(icao, mode, flight, land, gesellschaft, von, nach, ftype, alt, speed, heading, msg, adsb_ver, lat, lon);
        end;
      end;
      Flugloe;
      Application.ProcessMessages;
      sleep(300);
    end else begin
      Button2.Click;
      Label2.Caption:='Fehler beim Empfang der SDR-Daten';
    end;
  end;
end;

{
  Procedure FormClose
      Schließt das Programm
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  if Empfang then
  begin
    h1:=rtlsdr_cancel_async(sdropennum);
    Empfang:=False;
    CloseFile(tfOut);
  end;
  if msdropen then
  begin
    h1:=rtlsdr_close(sdropennum);
    msdropen:=False;
  end;
  if dcon = 1 then
  begin
    ZConnection1.Disconnect;
  end;
  Form1.Cursor:=crDefault;
  Form1.Refresh;
  CloseAction:=caFree;
end;

{
  Procedure FormActivate
      initialisiert Variable,
      setzt Ein- und Ausgabefelder von Form1.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormActivate(Sender: TObject);
  var
    h1: Tuint32_t;
    h2: integer;
    h3: Tuint32_t;
    h4: PChar;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  Form1.Caption:='             R T L S D R        ADS-B             Programmversion: '+vers+'          Username: '+BUser;
  if sta = 2 then
  begin
    sta:=1;
    mtasts:=1;
    mlauf:=0;
    Closestat:=0;
    sdrdevice:='';
    msdropen:=False;
    anzsdr:=0;
    msdrreceive:=False;
    adsbdev:=0;
    adsbgen:='';
    tuner:='';
    Timer1.Enabled:=False;
    Timer2.Enabled:=False;
    internet:=False;
    Empfang:=False;
    Memo1.Lines.Clear;
    ComboBox1.Text:='';
    ComboBox1.Items.Clear;
    ComboBox1.Color:=clSilver;
    ComboBox1.Enabled:=False;
    ComboBox1.ItemIndex:=-1;
    WVWindowParent1.Visible:=False;
    h1:=rtlsdr_get_device_count;
    if h1 > 0 then
    begin
      anzsdr:=h1;
      for h2:=0 to anzsdr-1 do
      begin
        h3:=h2;
        h4:=rtlsdr_get_device_name(h3);
        ComboBox1.Items.Add(h4);
      end;
    end;
    Loeflugtab;
    Loefluganz;
    if dcon = 0 then
    begin
      ZConnection1.Connect;
    end;
  end;
end;

{
  Procedure Button1Click
      Zur Auswahl des SDR-Devices
      in ComboBox1
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button1Click(Sender: TObject);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if not msdrreceive then
    begin
     if anzsdr > 0 then
      begin
        if msdropen then
        begin
          h1:=rtlsdr_close(sdropennum);
          msdropen:=False;
        end;
        Closestat:=1;
        mtasts:=0;
        mlauf:=1;
        ComboBox1.Color:=clWhite;
        ComboBox1.Enabled:=True;
        Form1.ActiveControl:=ComboBox1;
      end else begin
        Label2.Caption:='kein SDR-Device vorhanden';
      end;
    end else begin
      Label2.Caption:='ADS-B Empfang läuft, erst beenden';
    end;
  end;
end;

{
  Procedure Button2Click
      Holen ADS-B Daten vom SDR-Device
      Starten und Stopen,
      Timer starten.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button2Click(Sender: TObject);
  var
    h1: Tuint32_t;
    h2: longint;
    fname: string;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if msdropen then
    begin
      if msdrreceive then
      begin
        Button2.Caption:='Start Empfang';
        if Empfang then
        begin
          Empfang:=False;
          CloseFile(tfOut);
        end;
        msdrreceive:=False;
        internet:=False;
        Timer2.Enabled:=False;
      end else begin
        Memo1.Lines.Add('empfangene ASD-B Daten (14 Bytes lange Messages)');
        Memo1.Lines.Add('Hexadezimal-Werte            | Werte Numerisch         Hexa      Hexa           Hexa           Text             ');
        Memo1.Lines.Add('-----------------------------|----------------------------------------------------------------------------------');
        Loeflugtab;
        Loefluganz;
        Button2.Caption:='Stop Empfang';
        fname:='e:\RTLSDR\adsb\daten.dat';
        if Fileexists(fname) then
        begin
          Deletefile(fname);
        end;
        AssignFile(tfOut, fname);
        rewrite(tfOut);
        msdrreceive:=True;
        lat:=0;
        lon:=0;
        Timer1.Enabled:=True;
        Timer2.Enabled:=True;
        internet:=True;
      end;
    end else begin
      Label2.Caption:='noch kein SDR-Device ausgewählt';
    end;
  end;
end;

{
  Procedure Button3Click
      Beendet das Programm adsb
      nach Sicherheitsabfrage
      Close SDR-Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.Button3Click(Sender: TObject);
  var
    h1: longint;
begin
  Zeile1(Form1.Label1);
  Label2.Caption:='';
  if (mtasts = 1) then
  begin
    if (Closestat = 0) then
    begin
      if not msdrreceive then
      begin
        if msdropen then
        begin
          h1:=rtlsdr_close(sdropennum);
          msdropen:=False;
        end;
        mlauf:=0;
        close;
      end else begin
        Label2.Caption:='ADS-B Empfang läuft, erst beenden';
      end;
    end;
  end;
end;

{
  Procedure ComboBox1Change
      Auswahl des SDR-Devices und Open Device.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.ComboBox1Change(Sender: TObject);
 var
    h1: integer;
    h2: Trtlsdr_tuner;
    h3: PPrtlsdr_dev_t;
    h4: longint;
    h5: Trtlsdr_dev_t;
begin
  if (mlauf = 1) then
  begin
    Label2.Caption:='';
    if ComboBox1.Text <> '' then
    begin
      sdrdevice:=ComboBox1.Text;
      ComboBox1.Color:=clSilver;
      ComboBox1.Enabled:=False;
      h1:=Length(sdrdevice);
      if h1 > 0 then
      begin
        adsbdev:=ComboBox1.ItemIndex;
        adsbgen:=sdrdevice;
        tuner:='Tuner unbekannt';
        sdropennum:=@h5;
        h3:=@sdropennum;
        sdrdev:=rtlsdr_open(h3, adsbdev);
        if sdrdev < 0 then
        begin
          Label2.Caption:='SDR Device konnte nicht geöffnet werden';
          mlauf:=0;
          Closestat:=0;
          mtasts:=1;
        end else begin
          h2:=rtlsdr_get_tuner_type(sdropennum);
          if h2 = 1 then tuner:='Tuner E4000';
          if h2 = 2 then tuner:='Tuner FC0012';
          if h2 = 3 then tuner:='Tuner FC0013';
          if h2 = 4 then tuner:='Tuner FC2580';
          if h2 = 5 then tuner:='Tuner R280T';
          if h2 = 6 then tuner:='Tuner R828D';
          Memo1.Lines.Clear;
          Memo1.Lines.Add('ADS-B Device: '+IntToStr(adsbdev)+'    Generic: '+adsbgen);
          Memo1.Lines.Add('Tuner: '+tuner);
          Memo1.Lines.Add('Tuner-Gain: '+IntToStr(AUTO_GAIN)+' dB    Autogaincontrolled');
          Memo1.Lines.Add('Tuner-Frequenz: '+IntToStr(ADSB_FREQ)+' Hz');
          Memo1.Lines.Add('Sample-Rate: '+IntToStr(ADSB_RATE)+' S/s');
          Memo1.Lines.Add('');
          Memo1.Lines.Add('DF      = Datenformat                CA   = Transponderfähigkeit');
          Memo1.Lines.Add('Code    = Typencode');
          Memo1.Lines.Add('ICAO    = ICAO-Id (Hexadecimal)      PI   = Prüfzeichen und Zusatzinformation (Hexadecimal)');
          Memo1.Lines.Add('Message = Nachricht in Hexadecimal und Klartext');
          Loeflugtab;
          Loefluganz;
          msdropen:=True;
          h4:=rtlsdr_set_tuner_gain(sdropennum, AUTO_GAIN);
          h4:=rtlsdr_set_agc_mode(sdropennum, FUNC_ON);
          h4:=rtlsdr_set_center_freq(sdropennum, ADSB_FREQ);
          h4:=rtlsdr_set_sample_rate(sdropennum, ADSB_RATE);
          h4:=rtlsdr_set_bias_tee(sdropennum, FUNC_OFF);
          mlauf:=0;
          Closestat:=0;
          mtasts:=1;
        end;
      end else begin
        Label2.Caption:='Auswahl ist leer, neu wählen';
        Form1.ActiveControl:=ComboBox1;
      end;
    end else begin
      Label2.Caption:='SDR-Device muss ausgewählt werden';
      Form1.ActiveControl:=ComboBox1;
    end;
  end;
end;

{
  Procedure FormCloseQuery
      Fragt nach, ob das Programm beendet werden soll.
      Wenn Abfrage mit "No" beantwortet wird geht es ganz normal im Programm weiter.
      Außer wenn abbruch = True ist, dann wird sofort beendet.
  Eingabefelder = keine
  Ausgabefelder = keine
}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Zeile1(Form1.Label1);
  if (abbruch) then
  begin
    CanClose:=true;
  end else begin
    Form1.Cursor:=crDefault;
    Form1.Refresh;
    CanClose:=false;
    if (Closestat = 0) then
    begin
      JaNein:=QuestionDlg('Entscheidung', 'Programm-Ende', mtConfirmation, [mrYes, 'Ja', mrNo, 'Nein'], 0);
      if (JaNein = mrYes) then
      begin
        CanClose:=true;
      end;
    end;
  end;
end;

end.

